function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function upcastCommit(commit, upcasters) {
  let upcasted = false;

  if (upcasters) {
    const upcastedEvents = commit.events.map(event => {
      let updatedEvent = event;
      let upcaster;

      while (true) {
        const version = updatedEvent.version || 0;
        upcaster = upcasters[updatedEvent.type] && upcasters[updatedEvent.type][version];

        if (upcaster) {
          upcasted = true;
          updatedEvent = _extends({}, upcaster(updatedEvent), {
            version: version + 1
          });
        } else {
          break;
        }
      }

      return updatedEvent;
    });

    const upcastedCommit = _extends({}, commit, {
      events: upcastedEvents
    });

    Object.defineProperty(upcastedCommit, 'upcasted', {
      enumerable: false,
      configurable: false,
      writable: false,
      value: upcasted
    });
    return upcastedCommit;
  }

  return commit;
}

module.exports = upcastCommit;