function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

const WebSocket = require('ws');

const {
  $$asyncIterator
} = require('iterall');

const {
  EventEmitter
} = require('events');

class EventStream extends EventEmitter {
  constructor(_ref) {
    let {
      wsUrl,
      events
    } = _ref,
        optionsRest = _objectWithoutProperties(_ref, ["wsUrl", "events"]);

    super();
    this.setMaxListeners(0);
    this.socket = new WebSocket(wsUrl, optionsRest);
    this.socket.on('open', () => {
      this.socket.send(JSON.stringify(events));
    });
    this.socket.on('message', json => this.emit('newEvent', JSON.parse(json)));
    this.socket.on('error', () => this.socket = undefined);
    this.socket.on('close', () => (this.emit('close'), this.socket = undefined));
  }

  close() {
    return this.socket && this.socket.close();
  }

  [$$asyncIterator]() {
    const eventStream = this;
    const queue = [];
    this.socket.on('message', json => queue.push(JSON.parse(json)));
    return {
      next() {
        return _asyncToGenerator(function* () {
          while (true) {
            if (!eventStream.socket) {
              return {
                value: undefined,
                done: true
              };
            }

            if (queue.length) {
              return {
                value: queue.shift(),
                done: false
              };
            }

            yield Promise.race([new Promise(resolve => eventStream.socket.once('message', resolve)), new Promise(resolve => eventStream.socket.once('close', resolve)), new Promise(resolve => eventStream.socket.once('error', resolve))]);
          }
        })();
      },

      return() {
        return _asyncToGenerator(function* () {
          eventStream.close();
          return {
            value: undefined,
            done: true
          };
        })();
      },

      throw(error) {
        return _asyncToGenerator(function* () {
          eventStream.close();
          throw error;
        })();
      }

    };
  }

}

module.exports = EventStream;