function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

const config = require('../config');

const serializeCommit = require('./serializeCommit'); // Warning: Does not ensure consistency


function batchWriteCommits() {
  return _batchWriteCommits.apply(this, arguments);
}

function _batchWriteCommits() {
  _batchWriteCommits = _asyncToGenerator(function* ({
    aggregateType,
    aggregateKey = '@',
    commits,
    tableName = config.tableName,
    startVersion = 1
  } = {}) {
    const AWS = config.configuredAWS;
    const ddb = new AWS.DynamoDB();
    let i = 0;

    try {
      while (i < commits.length) {
        const versionOffset = i;
        yield ddb.batchWriteItem({
          RequestItems: {
            [tableName]: commits.slice(i, i + 25).map((commit, num) => ({
              PutRequest: {
                Item: serializeCommit(_extends({
                  aggregateType,
                  aggregateKey,
                  version: startVersion + versionOffset + num
                }, commit))
              }
            }))
          }
        }).promise();
        i += 25;
      }
    } catch (error) {
      throw error;
    }
  });
  return _batchWriteCommits.apply(this, arguments);
}

module.exports = batchWriteCommits;