function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

const config = require('../config');

function clearCommits() {
  return _clearCommits.apply(this, arguments);
}

function _clearCommits() {
  _clearCommits = _asyncToGenerator(function* ({
    tableName = config.tableName
  } = {}) {
    const ddb = new config.configuredAWS.DynamoDB();
    let queryResult;

    while (!queryResult || queryResult.LastEvaluatedKey) {
      queryResult = yield ddb.scan({
        TableName: tableName,
        ExclusiveStartKey: queryResult ? queryResult.LastEvaluatedKey : undefined
      }).promise();
      const {
        Items: items
      } = queryResult;
      let i = 0;

      while (i < queryResult.Items.length) {
        yield ddb.batchWriteItem({
          RequestItems: {
            [tableName]: items.slice(i, i + 25).map(item => ({
              DeleteRequest: {
                Key: {
                  a: item.a,
                  k: item.k
                }
              }
            }))
          }
        }).promise();
        i += 25;
      }
    }
  });
  return _clearCommits.apply(this, arguments);
}

module.exports = clearCommits;