function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

const queryCommits = require('./queryCommits');

const config = require('../config');

const {
  dateString
} = require('../utils');

const storeKeyString = require('./storeKeyString');

function getAggregateCommits(_ref = {}) {
  let {
    minVersion = 1,
    maxVersion = 10 ** config.versionDigits - 1,
    maxTime,
    aggregateKey = '@',
    consistentRead
  } = _ref,
      rest = _objectWithoutProperties(_ref, ["minVersion", "maxVersion", "maxTime", "aggregateKey", "consistentRead"]);

  return queryCommits(_extends({
    queryExpression: 'k BETWEEN :fromKeyAndVersion AND :toKeyAndVersion',
    queryVariables: {
      ':fromKeyAndVersion': storeKeyString(aggregateKey, minVersion),
      ':toKeyAndVersion': storeKeyString(aggregateKey, maxVersion)
    },
    filterExpression: maxTime ? 't <= :maxTime' : null,
    filterVariables: maxTime ? {
      ':maxTime': dateString(maxTime)
    } : null,
    consistentRead
  }, rest));
}

module.exports = getAggregateCommits;