function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

const deserializeCommit = require('./deserializeCommit');

const config = require('../config');

function getHeadCommit() {
  return _getHeadCommit.apply(this, arguments);
}

function _getHeadCommit() {
  _getHeadCommit = _asyncToGenerator(function* ({
    tableName = config.tableName
  } = {}) {
    const AWS = config.configuredAWS;
    const ddb = new AWS.DynamoDB();
    const {
      Items: [commitRecord]
    } = yield ddb.query({
      TableName: tableName,
      IndexName: 'commitIdIndex',
      Limit: 1,
      KeyConditionExpression: 'z = :z',
      ExpressionAttributeValues: {
        ':z': {
          S: 't'
        }
      },
      ScanIndexForward: false
    }).promise();
    return commitRecord && deserializeCommit(commitRecord);
  });
  return _getHeadCommit.apply(this, arguments);
}

module.exports = getHeadCommit;