function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

const defaultConfig = require('../config');

function clearSnapshots() {
  return _clearSnapshots.apply(this, arguments);
}

function _clearSnapshots() {
  _clearSnapshots = _asyncToGenerator(function* (config = defaultConfig) {
    const s3 = new config.configuredAWS.S3();
    let listResult;

    do {
      listResult = yield s3.listObjectsV2({
        Bucket: config.snapshotsBucket,
        Prefix: config.snapshotsPrefix,
        ContinuationToken: listResult ? listResult.NextContinuationToken : undefined
      }).promise();

      for (const _ref of listResult.Contents) {
        const {
          Key
        } = _ref;
        yield s3.deleteObject({
          Bucket: config.snapshotsBucket,
          Key
        }).promise();
      }
    } while (listResult.NextContinuationToken);
  });
  return _clearSnapshots.apply(this, arguments);
}

module.exports = clearSnapshots;