function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

const defaultConfig = require('../config');

function readAggregateSnapshot(_x) {
  return _readAggregateSnapshot.apply(this, arguments);
}

function _readAggregateSnapshot() {
  _readAggregateSnapshot = _asyncToGenerator(function* ({
    aggregateType,
    aggregateKey
  }, config = defaultConfig) {
    const s3 = new config.configuredAWS.S3();

    try {
      const {
        Body: snapshotJSON
      } = yield s3.getObject({
        Bucket: config.snapshotsBucket,
        Key: `${config.snapshotsPrefix}${aggregateType}_${aggregateKey}`
      }).promise();
      return JSON.parse(snapshotJSON);
    } catch (error) {
      if (error.code !== 'NoSuchKey') throw error;
      return null;
    }
  });
  return _readAggregateSnapshot.apply(this, arguments);
}

module.exports = readAggregateSnapshot;