function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

const defaultConfig = require('../config');

function writeAggregateSnapshot(_x) {
  return _writeAggregateSnapshot.apply(this, arguments);
}

function _writeAggregateSnapshot() {
  _writeAggregateSnapshot = _asyncToGenerator(function* ({
    aggregateType,
    aggregateKey,
    version,
    state,
    upcastersChecksum,
    headCommitTimestamp
  }, config = defaultConfig) {
    const s3 = new config.configuredAWS.S3();
    yield s3.putObject({
      Bucket: config.snapshotsBucket,
      Key: `${config.snapshotsPrefix}${aggregateType}_${aggregateKey}`,
      Body: JSON.stringify({
        version,
        state,
        upcastersChecksum,
        headCommitTimestamp
      })
    }).promise();
  });
  return _writeAggregateSnapshot.apply(this, arguments);
}

module.exports = writeAggregateSnapshot;