function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function parseKeyProperties({
  schema,
  props,
  separator = '.'
}) {
  if (!schema) return {
    keyString: '@',
    keyProps: {}
  };
  const keyProps = schema.reduce((key, keyProp) => {
    const propKey = typeof keyProp === 'string' ? keyProp : keyProp.name;

    if (typeof keyProp.value === 'function') {
      return _extends({}, key, {
        [propKey]: keyProp.value(props)
      });
    }

    if (props[propKey] != null || keyProp.optional) {
      return _extends({}, key, {
        [propKey]: props[propKey]
      });
    }

    throw new Error(`Missing required key property: ${propKey}`);
  }, {});
  return {
    keyString: Object.values(keyProps).join(separator),
    keyProps
  };
}

module.exports = parseKeyProperties;