function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

function randomIntInRange(min, max) {
  return Math.floor(Math.random() * (max - min + 1) + min);
}

class RetriesExhaustedError extends Error {
  constructor(...args) {
    super(...args);
    this.name = 'RetriesExhaustedError';
    Error.captureStackTrace(this, RetriesExhaustedError);
  }

}

function retryPromiseWithJitteredBackoff(_x) {
  return _retryPromiseWithJitteredBackoff.apply(this, arguments);
}

function _retryPromiseWithJitteredBackoff() {
  _retryPromiseWithJitteredBackoff = _asyncToGenerator(function* (fn, {
    initialDelay = 1,
    maxAttempts = 10,
    maxDelay = Infinity,
    beforeRetry,
    shouldRetry = () => true,
    backoffExponent = 2
  } = {}) {
    const errors = [];

    for (let attempt = 1; attempt <= maxAttempts; attempt++) {
      if (attempt > 1 && beforeRetry) {
        yield beforeRetry(errors[errors.length - 1], attempt);
      }

      try {
        return yield fn(attempt);
      } catch (error) {
        if (!(yield shouldRetry(error, attempt))) {
          throw error;
        }

        errors.push(error);
      }

      const delay = Math.min(maxDelay, randomIntInRange(0, initialDelay * backoffExponent ** attempt));
      yield new Promise(resolve => setTimeout(resolve, delay));
    }

    const exhaustionError = new RetriesExhaustedError(`Retries exhausted after ${maxAttempts} attempts`);
    exhaustionError.errors = errors;
    throw exhaustionError;
  });
  return _retryPromiseWithJitteredBackoff.apply(this, arguments);
}

module.exports = retryPromiseWithJitteredBackoff;