function _asyncIterator(iterable) { if (typeof Symbol === "function") { if (Symbol.asyncIterator) { var method = iterable[Symbol.asyncIterator]; if (method != null) return method.call(iterable); } if (Symbol.iterator) { return iterable[Symbol.iterator](); } } throw new TypeError("Object is not async iterable"); }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

const {
  dynamodb: {
    getAggregateCommits
  }
} = require('../../main');

const {
  pick
} = require('lodash');

function assertAggregateCommits(_x, _x2) {
  return _assertAggregateCommits.apply(this, arguments);
}

function _assertAggregateCommits() {
  _assertAggregateCommits = _asyncToGenerator(function* (t, {
    aggregateType,
    aggregateKey = '@',
    commits: providedCommits
  }, description = 'the aggregate has the expected commits') {
    const actualCommits = [];
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;

    var _iteratorError;

    try {
      for (var _iterator = _asyncIterator(getAggregateCommits({
        aggregateType,
        aggregateKey
      })), _step, _value; _step = yield _iterator.next(), _iteratorNormalCompletion = _step.done, _value = yield _step.value, !_iteratorNormalCompletion; _iteratorNormalCompletion = true) {
        const commit = _value;
        actualCommits.push(commit);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          yield _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    t.deepEqual(actualCommits.map((commit, i) => pick(commit, Object.keys(providedCommits[i] || commit))), providedCommits, description);
  });
  return _assertAggregateCommits.apply(this, arguments);
}

module.exports = assertAggregateCommits;