#!/usr/bin/env node
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

const ddbes = require('../../main');

const AWS = require('aws-sdk');

function setup() {
  return _setup.apply(this, arguments);
}

function _setup() {
  _setup = _asyncToGenerator(function* () {
    yield ddbes.dynamodb.createTable({
      readCapacityUnits: 10,
      writeCapacityUnits: 10
    });
    const s3 = new AWS.S3();

    try {
      yield s3.createBucket({
        Bucket: ddbes.config.snapshotsBucket
      }).promise();
    } catch (error) {
      if (!['BucketAlreadyExists', 'BucketAlreadyOwnedByYou'].includes(error.code)) {
        throw error;
      }
    }
  });
  return _setup.apply(this, arguments);
}

module.exports = setup;

if (require.main === module) {
  setup();
}