function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

const {
  dynamodb: {
    clearCommits
  },
  s3: {
    clearSnapshots
  }
} = require('../../main');

function withCleanup(_x) {
  return _withCleanup.apply(this, arguments);
}

function _withCleanup() {
  _withCleanup = _asyncToGenerator(function* (fn) {
    try {
      yield fn();
    } finally {
      yield Promise.all([clearCommits(), clearSnapshots()]);
    }
  });
  return _withCleanup.apply(this, arguments);
}

module.exports = withCleanup;